%define rhugversion 20031215
%define rhugsource1 %{name}-%{version} upstream
%define rhugpatches 3

Summary: Bytecode Engineering Library
Name: bcel
Version: 5.0
Release: 13
URL: http://jakarta.apache.org/bcel/
Source: rhug-%{name}-%{rhugversion}.tar.bz2
Source1: %{name}-%{version}-src.tar.gz
Patch1: %{name}-rhjpp.patch
Patch3: %{name}-jdk14.patch
License: Apache Software License
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: gcc34-c++
BuildPrereq: gcc34-java >= 3.4.0-1
BuildPrereq: jakarta-regexp >= 1.2-15
Prereq: redhat-java-rpm-scripts >= 1.0.2-2
Requires: libgcj34 >= 3.4.0-1
Requires: jakarta-regexp >= 1.2-15

%description
The Byte Code Engineering Library (formerly known as JavaClass) is
intended to give users a convenient possibility to analyze, create,
and manipulate (binary) Java class files (those ending with
.class). Classes are represented by objects which contain all the
symbolic information of the given class: methods, fields and byte code
instructions, in particular.

Such objects can be read from an existing file, be transformed by a
program (e.g. a class loader at run-time) and dumped to a file
again. An even more interesting application is the creation of classes
from scratch at run-time. The Byte Code Engineering Library (BCEL) may
be also useful if you want to learn about the Java Virtual Machine
(JVM) and the format of Java .class files.

%package devel
Summary: CNI headers for developing BCEL applications
Group: Development/Libraries
Requires: bcel = %{version}-%{release}

%description devel
The bcel-devel package contains the headers required to develop
Cygnus Native Interface (CNI) extensions that use BCEL.

%prep
%setup -q -a 1
mv %{rhugsource1}
%patch1 -p0 -b .rhjpp
%patch3 -p1 -b .jdk14
mv ChangeLog ChangeLog.rhug
mv TODO TODO.rhug

%build
CC=gcc34 CXX=g++34 GCJ=gcj34 GCJH=gcjh34 \
./configure \
    --disable-static \
    --prefix=%{_prefix} \
    --libdir=%{_libdir}
make

%install
rm -rf ${RPM_BUILD_ROOT}
%makeinstall
rm -f ${RPM_BUILD_ROOT}%{_libdir}/*.la
find ${RPM_BUILD_ROOT}%{_libdir} -type l | xargs rm -f

%post
%{_sbindir}/javaconfig \
    %{_libdir}/lib-org-apache-bcel.so \
    %{_datadir}/java/bcel.jar

%postun
%{_sbindir}/javaconfig \
    %{_libdir}/lib-org-apache-bcel.so \
    %{_datadir}/java/bcel.jar

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc *.rhug upstream/{LICENSE,README} upstream/docs
%{_libdir}/*.so
%{_datadir}/java/*.jar

%files devel
%defattr(-,root,root)
%{_includedir}/org/apache/bcel

%changelog
* Tue May  4 2004 Gary Benson <gbenson@redhat.com> 5.0-13
- Rebuild with new compiler.

* Thu Apr 15 2004 Gary Benson <gbenson@redhat.com> 5.0-12
- Rebuild with new compiler (#120844).

* Tue Mar  2 2004 Elliot Lee <sopwith@redhat.com>
- Rebuilt.

* Fri Feb 13 2004 Gary Benson <gbenson@redhat.com> 5.0-11
- Rebuild for Fedora.

* Mon Dec 15 2003 Gary Benson <gbenson@redhat.com>
- Apply hammer multilib fix to all multilib archs.
- Correctly link local libraries on hammer.

* Wed Dec 10 2003 Gary Benson <gbenson@redhat.com>
- Upgraded to fluorinated RHUG tarball.

* Fri Sep  5 2003 Gary Benson <gbenson@redhat.com> 5.0-10
- Ensure we have a working javaconfig.

* Thu Sep  4 2003 Gary Benson <gbenson@redhat.com>
- Remove workarounds used to support alpha releases.

* Fri Aug 15 2003 Gary Benson <gbenson@redhat.com> 5.0-9
- Rebuild with new compiler.

* Thu Aug  7 2003 Gary Benson <gbenson@redhat.com> 5.0-8
- Rebuild with new compiler.

* Fri Jul 25 2003 Gary Benson <gbenson@redhat.com> 5.0-7
- Clarify the -devel subpackage's summary and description.
- Remove unnecessary -devel build-time dependencies (#99077).

* Mon Jun 30 2003 Gary Benson <gbenson@redhat.com> 5.0-6
- Rebuild with new compiler and enable ia64 build.

* Fri Jun  6 2003 Gary Benson <gbenson@redhat.com> 5.0-5
- Rebuild with new compiler.

* Thu Jun  5 2003 Gary Benson <gbenson@redhat.com>
- Add build time dependency on C++ compiler.

* Thu May 29 2003 Gary Benson <gbenson@redhat.com> 5.0-4
- Rebuild with new compiler.

* Fri May 23 2003 Gary Benson <gbenson@redhat.com> 5.0-3
- Move unversioned library symlink into main package.

* Sat May  3 2003 Gary Benson <gbenson@redhat.com> 5.0-2
- Rebuild with new compiler.

* Fri Apr 26 2003 Gary Benson <gbenson@redhat.com> 5.0-1
- Initial Red Hat Linux build.

* Tue Nov 26 2002 Gary Benson <gbenson@redhat.com>
- Upgraded to 5.0.
- Added dependencies on gcc-java and libgcj.

* Sat Mar  2 2002 Anthony Green <green@redhat.com>
- Initial RHUG build.
